/// <reference types="node" />
import * as child from "child_process";
import TextStreamSearch from "text-stream-search";
declare type Env = {
    [key: string]: string;
};
declare type EndedNotification = {
    exitCode: number;
    killed: boolean;
};
export interface WriteStream {
    write(chunk: Buffer | string, encodingOrCallback?: string | Function, callback?: Function): boolean;
}
export default class ObservableProcess {
    cwd: string;
    ended: boolean;
    endedListeners: Array<(EndedNotification: any) => void>;
    env: Env;
    exitCode: number;
    killed: boolean;
    process: child.ChildProcess;
    stdout: WriteStream;
    stderr: WriteStream;
    stdin: WriteStream;
    textStreamSearch: TextStreamSearch;
    verbose: boolean;
    constructor(args: {
        command?: string;
        commands?: string[];
        env?: Env;
        verbose?: boolean;
        cwd?: string;
        stdout?: WriteStream | null;
        stderr?: WriteStream | null;
    });
    enter(text: string): void;
    fullOutput(): string;
    kill(): void;
    notifyEnded(): void;
    _onClose(exitCode: number): void;
    pid(): number;
    waitForEnd(): Promise<EndedNotification>;
    waitForText(text: string, timeout?: number): Promise<void>;
    resetOutputStreams(): void;
    _splitCommand(command: string | Array<string>): Array<string>;
}
export {};
